pipeline {
   agent any

    environment {
        PORT="80"
        IMAGE_TAG="expos-hr"
        CONTAINER_NAME="expos-hr-app"
        DB_URL=credentials('database-url')
        DB_USER=credentials('database-username')
        DB_PASS=credentials('database-password')
    }

   stages {
      stage('checkout'){
          steps {
               git branch: 'refactor', url: 'https://gitlab.com/210301-java-azure/karl_kanitsch/project-0-hr-admin-backend.git'
           }
      }
      stage('clean') {
         steps {
            sh 'sh gradlew clean'
         }
      }
      stage('package') {
         steps {
            sh 'sh gradlew finalJar'
         }
      }
      stage('remove previous image if exists') {
            steps {
                sh 'docker rmi -f ${IMAGE_TAG} || true'
            }
        }

       stage('create image') {
            steps {
                sh 'docker build -t ${IMAGE_TAG} -f Dockerfile .'
            }
        }
        stage('remove previous container if exists') {
            steps {
                sh 'docker stop ${CONTAINER_NAME} || true'
            }
        }
        stage('create container') {
            steps {
                sh 'docker run -d --rm -p ${PORT}:${PORT} -e ${DB_USER} -e ${DB_PASS} -e ${DB_URL} --name ${CONTAINER_NAME} ${IMAGE_TAG}'
            }
        }
    }
}
